tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL > Class Template Reference

`#include <_concurrent_skip_list_impl.h>`

Collaboration diagram for tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >:

## Public Member Functions

| concurrent_geometric_level_generator ()
size_t | operator() ()

## Static Public Attributes

static constexpr size_t | max_level = MAX_LEVEL

## Private Attributes

tbb::enumerable_thread_specific< std::mt19937_64 > | engines
std::geometric_distribution< size_t > | distribution

## Detailed Description

### template<size_t MAX_LEVEL>
class tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >

Definition at line 1066 of file _concurrent_skip_list_impl.h.

## Constructor & Destructor Documentation

## concurrent_geometric_level_generator()

template<size_t MAX_LEVEL>

tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >::concurrent_geometric_level_generator | ( |  | ) |

inline

Definition at line 1070 of file _concurrent_skip_list_impl.h.

: engines(time(NULL)) {}
tbb::interface10::internal::concurrent_geometric_level_generator::engines
tbb::enumerable_thread_specific< std::mt19937_64 > engines
Definition: _concurrent_skip_list_impl.h:1077

## Member Function Documentation

## operator()()

template<size_t MAX_LEVEL>

size_t tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >::operator() | ( |  | ) |

inline

Definition at line 1072 of file _concurrent_skip_list_impl.h.

{
return (distribution(engines.local()) % MAX_LEVEL) + 1;
}
tbb::interface10::internal::concurrent_geometric_level_generator::distribution
std::geometric_distribution< size_t > distribution
Definition: _concurrent_skip_list_impl.h:1078

References tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >::distribution, and tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >::engines.

## Member Data Documentation

## distribution

template<size_t MAX_LEVEL>

std::geometric_distribution<size_t> tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >::distribution

private

Definition at line 1078 of file _concurrent_skip_list_impl.h.

Referenced by tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >::operator()().

## engines

template<size_t MAX_LEVEL>

tbb::enumerable_thread_specific<std::mt19937_64> tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >::engines

private

Definition at line 1077 of file _concurrent_skip_list_impl.h.

Referenced by tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >::operator()().

## max_level

template<size_t MAX_LEVEL>

constexpr size_t tbb::interface10::internal::concurrent_geometric_level_generator< MAX_LEVEL >::max_level = MAX_LEVEL

static constexpr

Definition at line 1068 of file _concurrent_skip_list_impl.h.

The documentation for this class was generated from the following file:

- _concurrent_skip_list_impl.h

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.